%global srcname dijitso
# TODO: compile sphinx docs
Name:           python-%{srcname}
Version:        2017.2.0
Release:        0%{?dist}
Summary:        A Python module for distributed just-in-time shared library building

License:        LGPLv2+
URL:            http://www.fenicsproject.org
Source0:        https://bitbucket.org/fenics-project/dijitso/downloads/%{srcname}-%{version}.tar.gz
BuildArch:      noarch

BuildRequires:  python2-devel
BuildRequires:  python3-devel

%global _docdir_fmt %{name}

%description
This module was written to improve a core component of the FEniCS framework,
namely the just in time compilation of C++ code that is generated from Python
modules, but is only called from within a C++ library, and thus do not need
wrapping in a nice Python interface.

The main approach of dijitso is to use ctypes to import the dynamic shared
library directly with no attempt at wrapping it in a Python interface.

As long as the compiled code can provide a simple factory function to a class
implementing a predefined C++ interface, there is no limit to the complexity of
that interface as long as it is only called from C++ code, If you want a Python
interface to your generated code, dijitso is probably not the answer.

Although dijitso serves a very specific role within the FEniCS project, it does
not depend on other FEniCS components.

The parallel support depends on the mpi4py interface, although mpi4py is not
actually imported within the dijitso module so it would be possible to mock the
communicator object with a similar interface.

%package -n python2-%{srcname}
Summary:        %{summary}

%description -n python2-%{srcname}
This module was written to improve a core component of the FEniCS framework,
namely the just in time compilation of C++ code that is generated from Python
modules, but is only called from within a C++ library, and thus do not need
wrapping in a nice Python interface.

The main approach of dijitso is to use ctypes to import the dynamic shared
library directly with no attempt at wrapping it in a Python interface.

As long as the compiled code can provide a simple factory function to a class
implementing a predefined C++ interface, there is no limit to the complexity of
that interface as long as it is only called from C++ code, If you want a Python
interface to your generated code, dijitso is probably not the answer.

Although dijitso serves a very specific role within the FEniCS project, it does
not depend on other FEniCS components.

The parallel support depends on the mpi4py interface, although mpi4py is not
actually imported within the dijitso module so it would be possible to mock the
communicator object with a similar interface.

%package -n python3-%{srcname}
Summary:        %{summary}

%description -n python3-%{srcname}
This module was written to improve a core component of the FEniCS framework,
namely the just in time compilation of C++ code that is generated from Python
modules, but is only called from within a C++ library, and thus do not need
wrapping in a nice Python interface.

The main approach of dijitso is to use ctypes to import the dynamic shared
library directly with no attempt at wrapping it in a Python interface.

As long as the compiled code can provide a simple factory function to a class
implementing a predefined C++ interface, there is no limit to the complexity of
that interface as long as it is only called from C++ code, If you want a Python
interface to your generated code, dijitso is probably not the answer.

Although dijitso serves a very specific role within the FEniCS project, it does
not depend on other FEniCS components.

The parallel support depends on the mpi4py interface, although mpi4py is not
actually imported within the dijitso module so it would be possible to mock the
communicator object with a similar interface.

%prep
%setup -q -n %{srcname}-%{version}

%build
%py3_build
%py2_build

%install
%py3_install
%py2_install

%files -n python2-%{srcname}
%license COPYING
%doc ChangeLog.rst README.rst doc/sphinx/
%{python2_sitelib}/dijitso/
%{python2_sitelib}/*.egg-info
%{_mandir}/man*/*.1*
%{_bindir}/*

%files -n python3-%{srcname}
%license COPYING
%doc ChangeLog.rst README.rst doc/sphinx/
%{python3_sitelib}/dijitso/
%{python3_sitelib}/*.egg-info
%{_mandir}/man*/*.1*
%{_bindir}/*

%changelog
* Tue Apr 03 2018 Eldar Yusupov <eyusupov@gmail.com> - 2017.2.0
- Initial package for Fedora
